// generated by Fast Light User Interface Designer (fluid) version 1.0302

#ifndef gui_fl_hpp
#define gui_fl_hpp
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Value_Output.H>

class Plus4EmuGUI {
public:
  friend class Plus4EmuGUI_DiskConfigWindow; 
  friend class Plus4EmuGUI_DisplayConfigWindow; 
  friend class Plus4EmuGUI_KbdConfigWindow; 
  friend class Plus4EmuGUI_SoundConfigWindow; 
  friend class Plus4EmuGUI_MachineConfigWindow; 
  friend class Plus4EmuGUI_DebugWindow; 
  friend class Plus4EmuGUIMonitor; 
  friend class Plus4EmuGUI_PrinterWindow; 
  friend class Plus4EmuGUI_AboutWindow; 
private:
  Plus4Emu::VideoDisplay& display; 
  Plus4Emu::AudioOutput& audioOutput; 
  Plus4Emu::VirtualMachine& vm; 
  Plus4Emu::VMThread& vmThread; 
  Plus4Emu::EmulatorConfiguration& config; 
  Plus4Emu::FLTKDisplay_ *flDisplay; 
  Fl_Window *emulatorWindow; 
  uintptr_t mainThreadID; 
  int displayMode; 
  bool exitFlag; 
  bool errorFlag; 
  bool lightPenEnabled; 
  int oldWindowWidth; 
  int oldWindowHeight; 
  int oldDisplayMode; 
  int oldDemoStatus; 
  int32_t oldSpeedPercentage; 
  bool oldPauseFlag; 
  long oldTapeSampleRate; 
  int oldTapeSampleSize; 
  uint32_t oldFloppyDriveLEDState; 
  uint64_t oldFloppyDriveHeadPositions; 
  bool oldTapeReadOnlyFlag; 
  long oldTapePosition; 
  uint32_t functionKeyState; 
  int tapeButtonState; 
  int oldTapeButtonState; 
  std::string demoRecordFileName; 
  Plus4Emu::File *demoRecordFile; 
  std::string quickSnapshotFileName; 
  bool updateDisplayEntered; 
  bool debugWindowShowFlag; 
  bool debugWindowOpenFlag; 
  bool browseFileWindowShowFlag; 
  int browseFileStatus; 
  Fl_Native_File_Chooser *browseFileWindow; 
  Fl_Window *windowToShow; 
  std::string snapshotDirectory; 
  std::string demoDirectory; 
  std::string soundFileDirectory; 
  std::string configDirectory; 
  std::string loadFileDirectory; 
  std::string tapeImageDirectory; 
  std::string diskImageDirectory; 
  std::string romImageDirectory; 
  std::string prgFileDirectory; 
  std::string prgFileName; 
  std::string debuggerDirectory; 
  std::string screenshotDirectory; 
  std::string screenshotFileName; 
  Plus4Emu::ConfigurationDB guiConfig; 
  Plus4EmuGUI_DiskConfigWindow *diskConfigWindow; 
  Plus4EmuGUI_DisplayConfigWindow *displaySettingsWindow; 
  Plus4EmuGUI_KbdConfigWindow *keyboardConfigWindow; 
  Plus4EmuGUI_SoundConfigWindow *soundSettingsWindow; 
  Plus4EmuGUI_MachineConfigWindow *machineConfigWindow; 
  Plus4EmuGUI_DebugWindow *debugWindow; 
  Plus4EmuGUI_PrinterWindow *printerWindow; 
  Plus4EmuGUI_AboutWindow *aboutWindow; 
  Plus4Emu::JoystickInput joystickInput; 
  Plus4Emu::Timer statsTimer; 
  char windowTitleBuf[48]; 
  unsigned int savedSpeedPercentage; 
  int cursorPositionX; 
  int cursorPositionY; 
  int printerType; 
  void init_(); 
  void updateDisplay_windowTitle(); 
  void updateDisplay_windowMode(); 
  void updateDisplay_windowSize(); 
  void updateDisplay_floppyStats(uint64_t newFloppyDriveHeadPositions); 
public:
  void updateDisplay(double t = 0.025); 
  void errorMessage(const char *msg); 
private:
  Fl_Menu_Item& getMenuItem(int n); 
  int getMenuItemIndex(int n); 
  void createMenus(); 
public:
  void run(); 
private:
  void resizeWindow(int w, int h); 
  int handleMouseEvent(int event); 
  static int handleFLTKEvent(void *userData, int event); 
public:
  bool lockVMThread(size_t t = 2000); 
  void unlockVMThread(); 
  bool browseFile(std::string& fileName, std::string& dirName, const char *pattern, int type, const char *title); 
  void applyEmulatorConfiguration(bool updateWindowFlag_ = false); 
private:
  void updateMenu(); 
  static void errorMessageCallback(void *userData, const char *msg); 
  static void fileNameCallback(void *userData, std::string& fileName); 
  static void fltkCheckCallback(void *userData); 
  static void screenshotCallback(void *userData, const unsigned char *buf, int w_, int h_); 
  static void pollJoystickInput(void *userData); 
  bool closeDemoFile(bool stopDemo_); 
  void saveQuickConfig(int n); 
  static void menuCallback_File_LoadFile(Fl_Widget *o, void *v); 
  static void menuCallback_File_LoadConfig(Fl_Widget *o, void *v); 
  static void menuCallback_File_SaveConfig(Fl_Widget *o, void *v); 
  static void menuCallback_File_SaveMainCfg(Fl_Widget *o, void *v); 
  static void menuCallback_File_RevertCfg(Fl_Widget *o, void *v); 
  static void menuCallback_File_QSFileName(Fl_Widget *o, void *v); 
  static void menuCallback_File_QSLoad(Fl_Widget *o, void *v); 
  static void menuCallback_File_QSSave(Fl_Widget *o, void *v); 
  static void menuCallback_File_SaveSnapshot(Fl_Widget *o, void *v); 
  static void menuCallback_File_RecordDemo(Fl_Widget *o, void *v); 
  static void menuCallback_File_StopDemo(Fl_Widget *o, void *v); 
  static void menuCallback_File_RecordSound(Fl_Widget *o, void *v); 
  static void menuCallback_File_StopSndRecord(Fl_Widget *o, void *v); 
  static void menuCallback_File_RecordVideo(Fl_Widget *o, void *v); 
  static void menuCallback_File_StopAVIRecord(Fl_Widget *o, void *v); 
  static void menuCallback_File_Screenshot(Fl_Widget *o, void *v); 
  static void menuCallback_File_LoadPRG(Fl_Widget *o, void *v); 
  static void menuCallback_File_SavePRG(Fl_Widget *o, void *v); 
  static void menuCallback_File_Quit(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Pause(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_FullSpeed(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Speed_10(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Speed_25(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Speed_50(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Speed_100(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Speed_200(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Speed_400(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_OpenTape(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapePlay(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeStop(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeRecord(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeRewind(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapePrvCP(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeBwd10s(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeBwd60s(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeNxtCP(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeFwd10s(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeFwd60s(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_AddCP(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_DeleteCP(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_DeleteCPs(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_TapeClose(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_PrtShowWin(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_PrtSetType(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_PrtWrtFile(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_PrtASCII(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Reset(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_ColdReset(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_ResetFreqs(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_ResetAll(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_EnableSID(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_DisableSID(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_EnableLP(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_QuickCfgL1(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_QuickCfgL2(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_QuickCfgS1(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_QuickCfgS2(Fl_Widget *o, void *v); 
  static void menuCallback_Machine_Configure(Fl_Widget *o, void *v); 
  static void menuCallback_Options_DpySize1(Fl_Widget *o, void *v); 
  static void menuCallback_Options_DpySize2(Fl_Widget *o, void *v); 
  static void menuCallback_Options_DpySize3(Fl_Widget *o, void *v); 
  static void menuCallback_Options_DpyMode(Fl_Widget *o, void *v); 
  static void menuCallback_Options_DpyConfig(Fl_Widget *o, void *v); 
  static void menuCallback_Options_SndIncVol(Fl_Widget *o, void *v); 
  static void menuCallback_Options_SndDecVol(Fl_Widget *o, void *v); 
  static void menuCallback_Options_SndConfig(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRmA(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRmB(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRmC(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRmD(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRmv(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRpA(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRpB(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRpC(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRpD(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRpl(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRsA(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRsB(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRsC(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRsD(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyRst(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyGC(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FloppyCfg(Fl_Widget *o, void *v); 
  static void menuCallback_Options_PPriority(Fl_Widget *o, void *v); 
  static void menuCallback_Options_KbdConfig(Fl_Widget *o, void *v); 
  static void menuCallback_Options_FileIODir(Fl_Widget *o, void *v); 
  static void menuCallback_Debug_OpenDebugger(Fl_Widget *o, void *v); 
  static void menuCallback_Debug_DriveStats(Fl_Widget *o, void *v); 
  static void menuCallback_Help_About(Fl_Widget *o, void *v); 
public:
  Plus4EmuGUI(Plus4Emu::VideoDisplay& display_, Plus4Emu::AudioOutput& audioOutput_, Plus4Emu::VirtualMachine& vm_, Plus4Emu::VMThread& vmThread_, Plus4Emu::EmulatorConfiguration& config_) ;
  Fl_Window *mainWindow;
  Fl_Menu_Bar *mainMenuBar;
  Fl_Group *diskStatusDisplayGroup;
  Fl_Box *driveALEDDisplay;
  Fl_Box *driveAHeadDisplay;
  Fl_Box *driveBLEDDisplay;
  Fl_Box *driveBHeadDisplay;
  Fl_Box *driveCLEDDisplay;
  Fl_Box *driveCHeadDisplay;
  Fl_Box *driveDLEDDisplay;
  Fl_Box *driveDHeadDisplay;
  Fl_Group *statusDisplayGroup;
  Fl_Box *demoStatusDisplay1;
  Fl_Box *demoStatusDisplay2;
  Fl_Box *tapeInfoDisplay;
  Fl_Group *tapePositionDisplay;
  Fl_Box *tapeStatusDisplay;
  Fl_Double_Window *errorMessageWindow;
  Fl_Box *errorMessageText;
private:
  inline void cb_OK_i(Fl_Button*, void*);
  static void cb_OK(Fl_Button*, void*);
public:
  Fl_Double_Window *floppyStatsWindow;
  Fl_Value_Output *driveATrackDisplay;
  Fl_Value_Output *driveASideDisplay;
  Fl_Value_Output *driveASectorDisplay;
  Fl_Value_Output *driveBTrackDisplay;
  Fl_Value_Output *driveBSideDisplay;
  Fl_Value_Output *driveBSectorDisplay;
  Fl_Value_Output *driveCTrackDisplay;
  Fl_Value_Output *driveCSideDisplay;
  Fl_Value_Output *driveCSectorDisplay;
  Fl_Value_Output *driveDTrackDisplay;
  Fl_Value_Output *driveDSideDisplay;
  Fl_Value_Output *driveDSectorDisplay;
private:
  inline void cb_OK1_i(Fl_Button*, void*);
  static void cb_OK1(Fl_Button*, void*);
public:
  ~Plus4EmuGUI();
};
#endif
